package de.intevation.artifactdatabase.rest;

import org.w3c.dom.Document;

import org.restlet.ext.xml.DomRepresentation;

import org.restlet.resource.Post;  
import org.restlet.resource.ServerResource;

import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.data.Status;

import org.restlet.data.MediaType;

import org.apache.log4j.Logger;

import de.intevation.artifactdatabase.XMLUtils;
import de.intevation.artifactdatabase.Config;

import org.restlet.representation.Representation;
import org.restlet.representation.EmptyRepresentation;

import java.io.IOException;

/**
 * @author Sascha L. Teichmann (sascha.teichmann@intevation)
 */
public class CreateResource
extends      ServerResource
{
    private static Logger logger = Logger.getLogger(CreateResource.class);

    public static final String PATH = "/create";

    @Post("xml:xml")
    public Representation represent() {

        Request request = getRequest();

        Representation requestRepr = request.getEntity();

        Document inputDocument = null;
        try {
            DomRepresentation input = new DomRepresentation(requestRepr);
            inputDocument = input.getDocument();
        }
        catch (IOException ioe) {
            logger.error(ioe.getMessage());
            Response response = getResponse();
            response.setStatus(Status.CLIENT_ERROR_BAD_REQUEST, ioe);
            return new EmptyRepresentation();
        }
        
        Document outputDocument = XMLUtils.newDocument();

        return new DomRepresentation(
            MediaType.APPLICATION_XML, outputDocument);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
